
/*

The selection is a closed range in sample space (wave space). User
selects the range via GUI in pixel space (display space). The rule
is that when the selection is selected in pixel space, the selection
consists of samples which are under the selected pixels. Note that
if the selection is made in canvas display (with a large zoom) then
the rule holds only in canvas display not in the main display. The rule
is valid only in the display (with that particular zoom ratio) where the
selection is made.

New selection system should hide the conversions from the sample space
to the pixel space, and vice versa. Currently the XWave code is full
of conversions making the code look messy.

If the number samples/pixel is float, as it is in the main display,
conversions between the samples and the pixels should be carefully
tuned to be inverses of each other. Otherwise, round off error might
cause selection edges to move arbitrarily by one pixel, or such.

Alternatively, the selection system could store the selection also
in pixel space. In this alternative the sample space selection is
the selection because the selection is property of the wave not
a display, actually. The pixel space selection is used, for example,
for avoiding flicker: (i) selection is drawn in pixel space, (ii)
compute the selection in sample space, (iii) as long as the zoom is
not used, do not compute and redraw the selection by using sample space
values. The wave can be moved because movement doesn't alter the
samples/pixel value.

The conversion from sample space to pixel space is done only if
samples/pixel value changes.

To summary:
 -each display has info about the selection in the pixel space (of that
display);
 -


      wave        main display      canvas display
 sample range      pixel range        pixel range
 list of displays

each display has an ID;

adjustment done in main display:
 main display records its pixel selection;
 computes the sample selection and calls the routine which puts it to
 wave data;
  



Selection:











 */


typedef struct {
} ty_view;

typedef struct {
  int a,b;             /* selection range [a,b] */
  ty_view *views;      /* list of different views to the wave */
} ty_selection;

